package com.alihealth.d2d.provtest.factory;

import com.alihealth.d2d.provtest.service.handle.EventDataHandler;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * @author Jason 事件处理器工厂
 * @date 2025年06月05日 11:29:54
 */
@Service
public class EventHandlerFactory {
    @Autowired
    private Map<String, EventDataHandler> handlerMap;

    public EventDataHandler getHandler(String subType) {
        EventDataHandler handler = handlerMap.get(subType);
        if (handler == null) {
            throw new IllegalArgumentException("未找到对应的处理器: " + subType);
        }
        return handler;
    }
}
