package com.alihealth.d2d.provtest.utils;


import org.apache.commons.codec.binary.Base64;
import org.springframework.util.StringUtils;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

/**
 * 
 * @author xuwangyu
 *
 */
public class StreamUtil {
    /**
     * 将文件内容压缩并转为base64格式
     * @param fileName  文件名称
     * @param fileContent 文件内容
     * @return 压缩后Base64内容
     * @throws Exception
     */
    public static String getStreamContent(String fileName ,String fileContent) throws Exception {
    	if(StringUtils.isEmpty(fileName) || StringUtils.isEmpty(fileContent)) {
    		throw new NullPointerException();
    	}
        ByteArrayOutputStream bos = new ByteArrayOutputStream(5 * 1024 * 1024);
        ZipOutputStream zos = new ZipOutputStream(bos);
        InputStream is = new ByteArrayInputStream(fileContent.getBytes());
    	BufferedInputStream fileReader = new BufferedInputStream(is);
        zos.putNextEntry(new ZipEntry(fileName));
        byte[] b = new byte[1024];
        int i;
        while ((i = fileReader.read(b)) != -1) {
            zos.write(b, 0, i);
        }
        is.close();
        zos.closeEntry();
        zos.flush();
        zos.close();
        fileReader.close();
        bos.close();
        byte[] bytes = bos.toByteArray();
        return Base64.encodeBase64String(bytes);
    }

    /**
     * 先base64解密 后解压缩
     * @param s
     * @return
     */
    public static String getUnStreamContent(String s){
        byte[] bytes = Base64.decodeBase64(s);
        return new String(unZip(bytes));
    }

    /***
     * 解压Zip
     * @param data
     * @return
     */
    public static byte[] unZip(byte[] data) {
        byte[] b = null;
        try {
            ByteArrayInputStream bis = new ByteArrayInputStream(data);
            ZipInputStream zip = new ZipInputStream(bis);
            while (zip.getNextEntry() != null) {
                byte[] buf = new byte[1024];
                int num ;
                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                while ((num = zip.read(buf, 0, buf.length)) != -1) {
                    bos.write(buf, 0, num);
                }
                b = bos.toByteArray();
                bos.flush();
                bos.close();
            }
            zip.close();
            bis.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return b;
    }

}
